﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Infragistics45.Web.v21.1, Version=21.1.20211.2, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
    .hide {display:none;}
    </style>
</head>
<body>
    <form id="form1" runat="server">
    <input type="hidden" id="personId" runat="server" />
    <asp:ScriptManager ID="sm" EnablePartialRendering="true" runat="server">
        <Scripts>
			<asp:ScriptReference Assembly="Infragistics45.Web.v21.1, Version=21.1.20211.2, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Name="Infragistics.Web.UI.SharedScripts.igDragDrop.js" />
		</Scripts>
    </asp:ScriptManager>
            
    <asp:UpdatePanel runat="server">
        <ContentTemplate>
            <div id="dropSource">
                <ig:WebDataGrid ID="wdgSource" 
                Height="350px" Width="600px"
                runat="server" AutoGenerateColumns="False"
                DataKeyFields="ID">
                <Columns>
                    <ig:BoundCheckBoxField Header-Text="IsChecked" DataFieldName="IsChecked" Key="IsChecked"  Width="100px">  
                        <Header Text="IsChecked">
                        </Header>
                    </ig:BoundCheckBoxField>
                    <ig:BoundDataField Header-Text="ID" DataFieldName="ID" Key="ID"  Width="100px">  
                        <Header Text="ID">
                        </Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Header-Text="Name" DataFieldName="Name" Key="Name"  Width="100px">
                        <Header Text="Name">
                        </Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Header-Text="Age" DataFieldName="Age" Key="Age" Width="100px">
                        <Header Text="Age">
                        </Header>
                    </ig:BoundDataField>
                    <ig:BoundDataField Header-Text="HomeTown" DataFieldName="HomeTown" Key="HomeTown" Width="100px">
                        <Header Text="HomeTown">
                        </Header>
                    </ig:BoundDataField>
                </Columns>
                <Behaviors>
                    <ig:EditingCore>
                        <EditingClientEvents CellValueChanged="wdgSource_Editing_CellValueChanged" />
                        <Behaviors>
                            <ig:CellEditing>
                            </ig:CellEditing>
                        </Behaviors>
                    </ig:EditingCore>
                </Behaviors>
            </ig:WebDataGrid>
            </div>
           
            <div id="dropTarget">
                <ig:WebDataGrid ID="wdgTarget"
                runat="server" Height="350px" Width="600px"
                AutoGenerateColumns="False"
                DataKeyFields="ID">
                    <Columns>
                        <ig:BoundCheckBoxField Header-Text="IsChecked" DataFieldName="IsChecked" Key="IsChecked"  Width="100px">  
                            <Header Text="IsChecked">
                            </Header>
                        </ig:BoundCheckBoxField>
                        <ig:BoundDataField Header-Text="ID" DataFieldName="ID" Key="ID"  Width="100px">  
                            <Header Text="ID">
                            </Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField Header-Text="Name" DataFieldName="Name" Key="Name"  Width="100px">
                            <Header Text="Name">
                            </Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField Header-Text="Age" DataFieldName="Age" Key="Age" Width="100px">
                            <Header Text="Age">
                            </Header>
                        </ig:BoundDataField>
                        <ig:BoundDataField Header-Text="HomeTown" DataFieldName="HomeTown" Key="HomeTown" Width="100px">
                            <Header Text="HomeTown">
                            </Header>
                        </ig:BoundDataField>
                    </Columns>
                    <Behaviors>
                        <ig:EditingCore>
                            <EditingClientEvents CellValueChanged="wdgSource_Editing_CellValueChanged" />
                            <Behaviors>
                                <ig:CellEditing>
                                </ig:CellEditing>
                            </Behaviors>
                        </ig:EditingCore>
                    </Behaviors>
                </ig:WebDataGrid>
            </div>
             
            <asp:LinkButton ID="person" runat="server" CssClass="hide" onclick="person_Drag" />
            
        </ContentTemplate>
    </asp:UpdatePanel>
    
    </form>

</body>
<script type="text/javascript">
    var _dd;
    var rowToMove;
    Sys.Application.add_load(app_loaded);

    //初期ロード時にドラッグアンドドロップフレームワークで
    //ドラッグとドロップをできるように設定する
    function app_loaded() {
        //https://jp.infragistics.com/help/aspnet/16.2/draganddropframework-getting-started-with-drag-and-drop
        _dd = new $IG.DragDropBehavior();

        //_dd.get_events().addDragMoveHandler(move);
        _dd.get_events().addDropHandler(drop);

        var datagridSource = $find("wdgSource");
        var datagridTarget = $find("wdgTarget");

        var datagridSourceRows = datagridSource.get_rows();
        var datagridTargetRows = datagridTarget.get_rows();
        var count = datagridSourceRows.get_length();

        for (var i = 0; i < count; i++) {
            var sourceRow = datagridSourceRows.get_row(i).get_element();
            _dd.addSourceElement(sourceRow);
        }
        _dd.addTargetElement(document.getElementById("dropTarget"));
    }


    function drop(sender, eventArgs) {
        var source = eventArgs.get_manager().get_source().element;
        var manager = eventArgs.get_manager();
        var targetRow = manager.get_target().element;
        var checkedRows = new Array();

        var rows = $find("wdgSource").get_rows();

        //入れ替え対象の行 ID を取得
        for (var i = 0; i < rows.get_length() ; i++)
        {
            var row = rows.get_row(i);
            if (row.get_cellByColumnKey("IsChecked").get_value() === true) {
                checkedRows.push(row.get_cellByColumnKey("ID").get_value());
            }
        }
        
        //入れ替え対象の行 ID を保存
        $get("<%= personId.ClientID %>").value = checkedRows.join(',');
        //ポストバック
        __doPostBack("person", "");
    }
    
    //チェックボックスにチェックがあれば、入れ替え対象の行とみなす
    function wdgSource_Editing_CellValueChanged(sender, eventArgs) {
        var grid = sender;
        var colDataType = eventArgs.get_cell().get_column().get_type();
        if (colDataType == "boolean") {
            grid.get_behaviors().get_editingCore().commit();
        }
    }

    </script>
</html>
